package com.dbxml.db.core.query.plan.logical;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: ValueSet.java,v 1.2 2004/02/12 00:17:57 bradford Exp $
 */

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Collections;

/**
 * ValueSet
 */

public final class ValueSet extends Value {
   private static final Value[] EmptyValues = new Value[0];

   private List values = new ArrayList();

   public ValueSet() {
   }

   public ValueSet(Value[] values) {
      for ( int i = 0; i < values.length; i++ )
         this.values.add(values[i]);
   }

   public void addValue(Value value) {
      values.add(value);
   }

   public boolean contains(Value value) {
      return values.contains(value);
   }

   public Value getValue(int index) {
      return (Value)values.get(index);
   }

   public Value[] getValues() {
      return (Value[])values.toArray(EmptyValues);
   }

   public Iterator iterator() {
      return Collections.unmodifiableList(values).iterator();
   }

   public boolean equals(Object obj) {
      if ( obj instanceof ValueSet ) {
         ValueSet vs = (ValueSet)obj;
         if ( values.size() != vs.values.size() )
            return false;

         for ( int i = 0; i < values.size(); i++ )
            if ( !values.get(i).equals(vs.values.get(i)) )
                  return false;

         return true;
      }
      else
         return false;
   }
}
